SystemOrganization addCategory: #TPDBZ!

Object subclass: #Guerrero
	instanceVariableNames: 'nivelDePelea cantidadDeEnergia puntosDeVida aliados traje esferas semillasDelHermitanio'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TPDBZ'!

!Guerrero methodsFor: 'alianzas' stamp: 'RodolfoCaputo 10/14/2013 01:23'!
agregarAliado: unGuerrero
self aliados add: unGuerrero! !

!Guerrero methodsFor: 'accessing' stamp: 'ricardocascallares 10/14/2013 00:55'!
aliados
	^ aliados! !

!Guerrero methodsFor: 'accessing' stamp: 'ricardocascallares 10/14/2013 00:55'!
aliados: anObject
	aliados := anObject! !

!Guerrero methodsFor: 'accessing' stamp: 'ricardocascallares 10/14/2013 00:54'!
cantidadDeEnergia
	^ cantidadDeEnergia! !

!Guerrero methodsFor: 'accessing' stamp: 'ricardocascallares 10/14/2013 00:54'!
cantidadDeEnergia: anObject
	cantidadDeEnergia := anObject! !

!Guerrero methodsFor: 'alianzas' stamp: 'RodolfoCaputo 10/14/2013 01:36'!
concretarAlianzaCon: unGuerrero 
self agregarAliado: unGuerrero.
unGuerrero agregarAliado: self.! !

!Guerrero methodsFor: 'as yet unclassified' stamp: 'RodolfoCaputo 10/14/2013 01:51'!
esMasGrosoQue: unGuerrero
^((self nivelDePelea + self nivelesDePeleaAliados)> unGuerrero nivelDePelea).! !

!Guerrero methodsFor: 'accessing' stamp: 'ricardocascallares 10/14/2013 00:57'!
esferas
	^ esferas! !

!Guerrero methodsFor: 'accessing' stamp: 'ricardocascallares 10/14/2013 00:57'!
esferas: anObject
	esferas := anObject! !

!Guerrero methodsFor: 'accessing' stamp: 'ricardocascallares 10/14/2013 00:54'!
nivelDePelea
	^ nivelDePelea! !

!Guerrero methodsFor: 'accessing' stamp: 'ricardocascallares 10/14/2013 00:54'!
nivelDePelea: anObject
	nivelDePelea := anObject! !

!Guerrero methodsFor: 'as yet unclassified' stamp: 'RodolfoCaputo 10/14/2013 01:49'!
nivelesDePeleaAliados
self aliados collect:[ :unAliado | unAliado nivelDePelea] sum.! !

!Guerrero methodsFor: 'accessing' stamp: 'RodolfoCaputo 10/14/2013 01:09'!
puntosDeVida
	^ puntosDeVida! !

!Guerrero methodsFor: 'accessing' stamp: 'RodolfoCaputo 10/14/2013 01:10'!
puntosDeVida: anObject
	puntosDeVida := anObject! !

!Guerrero methodsFor: 'accessing' stamp: 'ricardocascallares 10/14/2013 00:57'!
semillasDelHermitanio
	^ semillasDelHermitanio! !

!Guerrero methodsFor: 'accessing' stamp: 'ricardocascallares 10/14/2013 00:57'!
semillasDelHermitanio: anObject
	semillasDelHermitanio := anObject! !

!Guerrero methodsFor: 'as yet unclassified' stamp: 'RodolfoCaputo 10/14/2013 01:45'!
tieneAmigosMasGrososQue: unNivelDePelea 
^((self nivelDePelea + self nivelesDePeleaAliados)> unNivelDePelea).! !

!Guerrero methodsFor: 'accessing' stamp: 'ricardocascallares 10/14/2013 00:54'!
traje
	^ traje! !

!Guerrero methodsFor: 'accessing' stamp: 'ricardocascallares 10/14/2013 00:54'!
traje: anObject
	traje := anObject! !

Guerrero subclass: #Monstruo
	instanceVariableNames: 'nivelDePelea cantidadDeEnergia puntosDeVida aliados traje esferas semillasDelHermitanio'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TPDBZ'!

!Monstruo methodsFor: 'alianzas' stamp: 'RodolfoCaputo 10/14/2013 01:36'!
aliarseCon: unGuerrero 
self concretarAlianzaCon: unGuerrero ! !

!Monstruo methodsFor: 'as yet unclassified' stamp: 'ricardoCascallares 10/14/2013 17:29'!
podesHacer: unAtaque 
^ unAtaque puedeRealizarsePorMonstruo: self  ! !

Guerrero subclass: #Saiyajin
	instanceVariableNames: 'nivelDePelea cantidadDeEnergia puntosDeVida aliados traje esferas semillasDelHermitanio'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TPDBZ'!

!Saiyajin methodsFor: 'alianzas' stamp: 'RodolfoCaputo 10/14/2013 02:07'!
aliarseCon: unGuerrero
(unGuerrero esMasGrosoQue: self) ifTrue:[^'aca habra q lanzar una excepcion'] ifFalse:[ self concretarAlianzaCon: unGuerrero ]! !

!Saiyajin methodsFor: 'as yet unclassified' stamp: 'ricardoCascallares 10/14/2013 17:35'!
podesHacer: unAtaque
^unAtaque puedeRealizarsePorSaiyajin: self ! !

Guerrero subclass: #Terricola
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TPDBZ'!

!Terricola methodsFor: 'as yet unclassified' stamp: 'ricardoCascallares 10/14/2013 17:22'!
podesHacer: unPoder 
^unPoder  puedeRealizarsePorTerricola: self ! !

Object subclass: #PoderColectivo
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TPDBZ'!

!PoderColectivo methodsFor: 'as yet unclassified' stamp: 'ricardoCascallares 10/14/2013 17:50'!
puedeRealizarsePorMonstruo: unMonstruo 
^ true! !

!PoderColectivo methodsFor: 'as yet unclassified' stamp: 'ricardoCascallares 10/14/2013 17:51'!
puedeRealizarsePorSaiyajin: unSaiyajin
^ true! !

!PoderColectivo methodsFor: 'as yet unclassified' stamp: 'ricardoCascallares 10/14/2013 17:52'!
puedeRealizarsePorTerricola: unTerricola 
^true! !

Object subclass: #PoderLiviano
	instanceVariableNames: 'puntosDeAtaque'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TPDBZ'!

!PoderLiviano methodsFor: 'as yet unclassified' stamp: 'ricardoCascallares 10/14/2013 18:10'!
puedeRealizarsePorMonstruo: unMonstruo
^ unMonstruo  cantidadDeEnergia  > 50! !

!PoderLiviano methodsFor: 'as yet unclassified' stamp: 'ricardoCascallares 10/14/2013 18:10'!
puedeRealizarsePorSaiyajin: unSaiyajin
^ unSaiyajin  cantidadDeEnergia  > 50! !

!PoderLiviano methodsFor: 'as yet unclassified' stamp: 'ricardoCascallares 10/14/2013 18:11'!
puedeRealizarsePorTerricola: unTerricola 
^unTerricola cantidadDeEnergia  > 50! !

!PoderLiviano methodsFor: 'accessing' stamp: 'ricardocascallares 10/14/2013 01:37'!
puntosDeAtaque
	^ puntosDeAtaque! !

!PoderLiviano methodsFor: 'accessing' stamp: 'ricardocascallares 10/14/2013 01:37'!
puntosDeAtaque: anObject
	puntosDeAtaque := anObject! !

Object subclass: #PoderPotente
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TPDBZ'!

!PoderPotente methodsFor: 'as yet unclassified' stamp: 'ricardoCascallares 10/14/2013 17:47'!
puedeRealizarsePorMonstruo: unMonstruo 
^ true! !

!PoderPotente methodsFor: 'as yet unclassified' stamp: 'ricardoCascallares 10/14/2013 17:47'!
puedeRealizarsePorSaiyajin: unSaiyajin
^ true! !

!PoderPotente methodsFor: 'as yet unclassified' stamp: 'ricardoCascallares 10/14/2013 18:21'!
puedeRealizarsePorTerricola: unTerricola 
^((unTerricola cantidadDeEnergia ) * 0.25) < 500! !

Object subclass: #PoderVengativo
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TPDBZ'!
